/********************************************/
/* Denteblu 1.4 by Rod                      */
/*                                          */
/* Just a simple Bluetooth serial           */
/* communication program                    */
/* It's for Palm OS Developer Suite 1.1 but */
/* you can adapt it to other environments   */
/* It's given to you in a 'AS IS' basis     */
/* You are free to use it in your software  */
/* Search for TODO to experiment changes    */
/* Remember to change the creator ID in     */
/* project files too                        */
/* It's released with GPL license.          */
/* http://www.webalice.it/rodolfo.turco     */
/* rodolfo.turco@virgilio.it                */
/********************************************/

//TODO for semplicity this application is without
// errors management, you have to implement it

#include"PalmOS.h"
//#include "PalmChars.h"
#include "BtCommVdrv.h"

/* Interface IDs */
#define MainForm         1000
#define RomIncompAlert   1100
#define GENERICALERT     1101
#define CONN_BUTT        1200
#define SEND_BUTT        1201
#define REC_BUTT         1202
#define CLOSE_BUTT       1203
#define FIND_BUTT        1204
#define MenuHelp         1301
#define MenuExit         1302 //Someone doesn't like an exit function. I do! Bad habit but freedom ;-)
#define MenuAbout        1303
#define SEND_EDIT        1400
#define REC_EDIT         1401
#define A_NUMBER         1500
#define ABOUTALERT       1600
#define HELP_TEXT        1900 //TODO a static resource help text

#define AppCreator          '???2'     //TODO set your Application Creator ID
#define sysFileTApplication 'appl'
#define MinVersion		        0x05000000 //TODO set your minimal version number here (this is 5.0)
/************************************/
/* Functions                        */
/************************************/
static Err RomVersionCompatible(UInt32 requiredVersion,UInt16 launchFlags);
static void *getObjectPtr(FormPtr frmP,UInt16 unID);
void GetString(UInt16 unID,char *cOutString,UInt16 unLen);
void SetString(UInt16 unID,char *cString);
static Boolean doMenu(FormPtr frmP, UInt16 command);
Boolean PreprocessEvent(EventPtr eventP);
Boolean mainFormEventHandler(EventPtr eventP);
void startApp();
void stopApp();
Boolean appHandleEvent(EventPtr event);
UInt32 PilotMain(UInt16 cmd,void *cmdPBP,UInt16 launchFlags);
/************************************/
/* Application preferences          */
/************************************/
typedef struct {
 //TODO declare here your preference variables
 UInt8  cAddress[6];
} Prefs;
/************************************/
/* Global variables                 */
/************************************/
static char   cSendStringa[50];
static char   cRecStringa[410];
static Prefs   prefs;

/**************/
/* BT Globals */
/**************/
static UInt16 unPortId;
static UInt16 btLibRefNum;
static Err err;
static SrmOpenConfigType config;
static BtVdOpenParams    btParams;
static BtLibSdpUuidType  sppUuid;

/************************************/
/* Pause n milliseconds             */
/************************************/
static void Uti_WaitMilliSec(UInt32 ulMilliSec)
{
 UInt16  unTickPerSec;

 unTickPerSec=SysTicksPerSecond();
 if(unTickPerSec)
  SysTaskDelay(ulMilliSec*unTickPerSec/1000);
 else
  SysTaskDelay(ulMilliSec/10);
}
/***************************************/
/* Close a Bluetooth serial connection */
/***************************************/
static void BT_Close()
{
 if(unPortId)
  {
   WinDrawChars("Close     ",10,80,0);
   SrmClose(unPortId);
   Uti_WaitMilliSec(500);
   SrmClose(unPortId);
   unPortId=0;
  }
}
/**************************************/
/* Open a Bluetooth serial connection */
/**************************************/
static void BT_Open()
 {
  BT_Close();

  MemSet(&sppUuid, sizeof(sppUuid), 0);
  sppUuid.size = btLibUuidSize16;
  sppUuid.UUID[0] = 0x11;
  sppUuid.UUID[1] = 0x01;
  MemSet(&btParams, sizeof(btParams), 0);
  btParams.u.client.remoteDevAddr.address[0]=prefs.cAddress[0];
  btParams.u.client.remoteDevAddr.address[1]=prefs.cAddress[1];
  btParams.u.client.remoteDevAddr.address[2]=prefs.cAddress[2];
  btParams.u.client.remoteDevAddr.address[3]=prefs.cAddress[3];
  btParams.u.client.remoteDevAddr.address[4]=prefs.cAddress[4];
  btParams.u.client.remoteDevAddr.address[5]=prefs.cAddress[5];
  btParams.role = btVdClient;
  btParams.u.client.method = btVdUseUuidList;
  btParams.u.client.u.uuidList.tab = &sppUuid;
  btParams.u.client.u.uuidList.len = 1;
  MemSet(&config, sizeof(config), 0);
  config.function = serFncUndefined; //serFncTelephony;//serFncUndefined;
  config.drvrDataP = (MemPtr)&btParams;
  config.drvrDataSize = sizeof(btParams);

  err=SrmExtOpen(sysFileCVirtRfComm,&config,sizeof(config),&unPortId);
  
  if(err==0)
   WinDrawChars("Open      ",10,80,0);
  else
   WinDrawChars("Error1    ",10,80,0);
 }
/***************************/
/* Find a BT device on air */
/***************************/
static void BT_FindDevice()
{
 BT_Close();

 if(btLibRefNum)
  {
   err=BtLibOpen(btLibRefNum,false);
   if(err==0)
    {
     err=BtLibDiscoverSingleDevice(btLibRefNum,NULL,NULL,0,
             (BtLibDeviceAddressType *)(prefs.cAddress),false,true);
     if(err)
      WinDrawChars("Error2    ",10,80,0);
     else
      WinDrawChars("Found     ",10,80,0);
    }
   BtLibClose(btLibRefNum);
  }
}
/***********************/
/* Load the BT library */
/***********************/
static void BT_LoadLibrary()
{
 btLibRefNum=0;

 err=SysLibFind("Bluetooth Library",&btLibRefNum);

 if(err)
  err=SysLibLoad(sysFileTLibrary,sysFileCBtLib,&btLibRefNum);

 if(err)
  WinDrawChars("Error3    ",10,80,0);
}
/****************/
/* Flush BT ser */
/****************/
static void BT_Flush(UInt16 unTimeout)
{
 if(unPortId)
  {
   err=SrmReceiveFlush(unPortId,unTimeout);
   if(err)
    WinDrawChars("Error4    ",10,80,0);
  }
}
/****************/
/* Send BT data */
/****************/
static void BT_Send(char * pData,UInt16 unLen)
{
 if(unPortId)
  {
   SrmSend(unPortId,pData,unLen,&err);
   if(err)
    WinDrawChars("Error5    ",10,80,0);
   else
    WinDrawChars("Okay5     ",10,80,0);
  }
}
/*******************/
/* Receive BT data */
/*******************/
static void BT_Receive(char * pData,UInt16 unLen,UInt16 unTimeout)
{
 UInt16 unLenRead;
 if(unPortId)
  {
   unLenRead=SrmReceive(unPortId,pData,unLen,unTimeout,&err);
   if((err==0)||(err==serErrTimeOut))
    WinDrawChars("Okay      ",10,80,0);
   pData[unLenRead]=0;
   if(unLenRead==0)
    WinDrawChars("No data   ",10,80,0);
  }
}

/************************************/
static void SendData()
{
 MemSet(cSendStringa,sizeof(cSendStringa),0);
 GetString(SEND_EDIT,cSendStringa,40);
 StrCat(cSendStringa,"\r");
 BT_Send(cSendStringa,StrLen(cSendStringa));
}
/************************************/
static void RecData()
{
 MemSet(cRecStringa,sizeof(cRecStringa),0);
 BT_Receive(cRecStringa,400,100);
 SetString(REC_EDIT,cRecStringa);
}
/************************************/
/* Checks the Rom version           */
/************************************/
static Err RomVersionCompatible(UInt32 requiredVersion,UInt16 launchFlags)
{
	UInt32 romVersion;

	FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);
	if(romVersion < requiredVersion)
		{
		if((launchFlags&(sysAppLaunchFlagNewGlobals|sysAppLaunchFlagUIApp))==
			(sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp))
			{
    FrmAlert(RomIncompAlert);
			 if (romVersion < 0x02000000)
				 {				
				  AppLaunchWithCommand(sysFileCDefaultApp,sysAppLaunchCmdNormalLaunch,NULL);
				 }
			}
		return (sysErrRomIncompatible);
		}
	return 0;
}
/**************************************************/
/* Get the Object pointer needed to some function */
/**************************************************/
static void *getObjectPtr(FormPtr frmP,UInt16 unID)
{
 UInt16 fldIndex=FrmGetObjectIndex(frmP,unID);
 return FrmGetObjectPtr(frmP,fldIndex);
}
/************************************/
/* Get a string from an edit field  */
/************************************/
void GetString(UInt16 unID,char *cString,UInt16 unLen)
{
 FormPtr frmP = FrmGetActiveForm();
 FieldPtr fldP = getObjectPtr(frmP, unID);
 MemHandle h = FldGetTextHandle(fldP);
 if(h!=NULL)
  {
   char *p = MemHandleLock(h);
   StrNCopy(cString,p,unLen);
   MemHandleUnlock(h);
  }
 else
  cString[0]=0;
}
/**********************************/
/* Set a string on an edit field  */
/**********************************/
void SetString(UInt16 unID,char *cString)
{
 char *p;
 UInt16 unLen;
 MemHandle h;
 FormPtr frmP = FrmGetActiveForm();
 FieldPtr fldP = getObjectPtr(frmP,unID);
 MemHandle oldH = FldGetTextHandle(fldP);

 unLen=StrLen(cString);
 h = MemHandleNew(unLen + 1);
 p = (char *)MemHandleLock(h);
 StrCopy(p,cString);
 MemHandleUnlock(h);
 FldSetTextHandle(fldP, h);
 FldDrawField(fldP);
 if(oldH)
  MemHandleFree(oldH);
}
/************************************/
/* Menu events management           */
/************************************/
static Boolean doMenu(FormPtr frmP, UInt16 command)
{
 EventType event;
 Boolean handled = false;

 switch(command)
  {
   case MenuAbout:
    FrmAlert(ABOUTALERT);
    handled = true; 
    break;
   case MenuHelp:
    FrmHelp(HELP_TEXT);
    handled = true; 
    break;
   case MenuExit:
    MemSet(&event,sizeof(event),0);
    event.eType = keyDownEvent;
    event.data.keyDown.chr = vchrLaunch;
    event.data.keyDown.modifiers = commandKeyMask;
    EvtAddEventToQueue(&event);
    handled = true;
    break;
   default:
    break;
  }
 return handled;
}
/*************************************************/
/* You may need to preprocess events, do it here */
/*************************************************/
Boolean PreprocessEvent(EventPtr eventP)
{
 Boolean handled = false;
 WChar   chrPress;

 chrPress=eventP->data.keyDown.chr;

 switch(eventP->eType)
  {
   case keyDownEvent:
    switch(chrPress) //TODO you may wish to handle key events...
     {
      case vchrHard1:// button 1
       BT_FindDevice();
       BT_Open();
       BT_Flush(100);
       handled=true; 
       break;
      case vchrHard2:// button 2
       SendData();
       handled=true;
       break;
      case vchrHard3:// button 3
       RecData();
       handled=true;
       break;
      case vchrHard4:// button 4
       BT_Close();
       handled=true;
       break;
      default:
       break;
     }
    break;
   default:
    break;
  }

 return handled;
}
/************************************/
/* MainForm events handled here     */
/************************************/
Boolean mainFormEventHandler(EventPtr eventP)
{
 Boolean handled = false;
 FormPtr frmP = FrmGetActiveForm();
 UInt16 unFrmID;

 switch(eventP->eType)
  {
   case frmOpenEvent:// open a form
    FrmDrawForm(frmP);
    unFrmID=FrmGetActiveFormID();
    if(unFrmID==MainForm)// it's the main form
     {
     }
    handled = true; 
    break; 
   case menuEvent: 
    handled=doMenu(frmP, eventP->data.menu.itemID); 
    break; 
   case ctlSelectEvent:
    switch (eventP->data.ctlSelect.controlID) 
     {
      case FIND_BUTT:
       BT_FindDevice();
       handled = true; 
       break;
      case CONN_BUTT:
       BT_Open();
       BT_Flush(100);
       handled = true; 
       break;
      case SEND_BUTT:
       SendData();
       handled = true; 
       break;
      case REC_BUTT:
       RecData();
       handled = true; 
       break;
      case CLOSE_BUTT:
       BT_Close();
       handled = true; 
       break;
      default:
       break;
     }
    break;
   default:
    break;
  }
 return handled;
}
/************************************/
/* Application events handled here  */
/************************************/
Boolean appHandleEvent(EventPtr event)
{
 FormPtr  frm;
 Int16    formId;
 Boolean  handled = false;

 if(event->eType == frmLoadEvent) /* Form loading */
  { 
   formId = event->data.frmLoad.formID; 
   frm = FrmInitForm(formId); 
   FrmSetActiveForm(frm); 

   if(formId==MainForm)
    FrmSetEventHandler(frm,mainFormEventHandler);

   handled = true;
  }
 return handled;
}
/************************************/
/* Called at start                  */
/************************************/
void startApp()
{
	UInt16 prefSize = sizeof(Prefs);

 //Load application preferences
	if((PrefGetAppPreferences(AppCreator,0,&prefs,&prefSize,true)==noPreferenceFound)
			||(prefSize != sizeof(Prefs)))
  {
   //TODO set default preference values here
   prefs.cAddress[0]=0;
   prefs.cAddress[1]=0;
   prefs.cAddress[2]=0;
   prefs.cAddress[3]=0;
   prefs.cAddress[4]=0;
   prefs.cAddress[5]=0;
   PrefSetAppPreferences(AppCreator,0,1,&prefs,sizeof(Prefs),true);
	 }

 unPortId = 0;
 btLibRefNum = 0;
 BT_LoadLibrary();
}
/************************************/
/* Called at exit                   */
/************************************/
void stopApp()
{
 //TODO you may need to do something here
 PrefSetAppPreferences(AppCreator,0,1,&prefs,sizeof(Prefs),true);
 BT_Close();
}
/************************************/
/* The main program function        */
/************************************/
UInt32 PilotMain(UInt16 cmd,void *cmdPBP,UInt16 launchFlags)
{
 EventType event;
 UInt16    error;

 switch(cmd)
  {
   case sysAppLaunchCmdNormalLaunch:
	   error=RomVersionCompatible(MinVersion,launchFlags);
    if(error==0)
     {
      startApp();
      FrmGotoForm(MainForm);
      do 
       { 
        EvtGetEvent(&event,30); 

        if(PreprocessEvent(&event)) 
         continue; 

        if(!SysHandleEvent(&event)) 
         if(!MenuHandleEvent(0,&event,&error)) 
          if(!appHandleEvent(&event)) 
           FrmDispatchEvent(&event); 
       } 
      while(event.eType != appStopEvent); 
      FrmCloseAllForms();
      stopApp();
     }
    break;
  }
 return 0; 
}
